//
//  DXIsbnSearcher.h
//  Lesemaus
//
//  Created by Oliver Kahrmann on 15.01.11.
//  Copyright 2011 DHELIXSoft. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "DXIsbnResultParser.h"
#import <WebKit/WebFrame.h>
#import <WebKit/WebDataSource.h>
#import "HTMLParser.h"
#import "HTMLNode.h"
#import "DXIsbnParserForWeltbild.h"
#import "DXIsbnParserForBuecherDE.h"
#import "DXIsbnParserForMVBBuchhandelDE.h"


@interface DXIsbnSearcher : NSObject {
	IBOutlet NSProgressIndicator *statusIndicator;
	IBOutlet NSTextField *outLabel;
	
	IBOutlet NSTextField *titleField;
	IBOutlet NSTextField *authorField;
	IBOutlet NSTextField *publisherField;
	IBOutlet NSImageView *imageView;
	IBOutlet NSDatePicker *dateField;
	
	IBOutlet NSArrayController *buchArray;
	
	IBOutlet NSSearchField *searchField;
	IBOutlet NSCollectionView *resultsView;
	
	NSMutableArray *results;
	NSMutableArray *alternateResults;
	
	NSThread *searchThread;
}

-(void)searchForIsbnUsingString:(NSString *)isbnToSearch;
-(IBAction)searchForIsbn:(id)sender;

-(void)searchForIsbn:(NSString *)isbn usingParser:(DXIsbnResultParser *)parser;

- (void)insertResultDictionary:(NSDictionary *)aDitctionary;

- (NSArray *)results;
- (unsigned)countOfResults;
- (id)objectInResultsAtIndex:(unsigned)theIndex;
- (void)getResults:(id *)objsPtr range:(NSRange)range;
- (void)insertObject:(id)obj inResultsAtIndex:(unsigned)theIndex;
- (void)removeObjectFromResultsAtIndex:(unsigned)theIndex;
- (void)replaceObjectInResultsAtIndex:(unsigned)theIndex withObject:(id)obj;



@end

